%define libxml2_version 2.4.12
%define glib2_version 2.25.9
%define dbus_version 1.0.1
%define dbus_glib_version 0.74

%if !0%{?flatpak}
%define defaults_service 1
%endif

Name:    GConf2
Version: 3.2.6
Release:    2%{?dist}
Summary: A process-transparent configuration system

License: LGPLv2+ and GPLv2+
URL:     https://gitlab.gnome.org/Archive/gconf/
Source0: https://download.gnome.org/sources/GConf/3.2/GConf-%{version}.tar.xz
Source1: macros.gconf2

Patch0: GConf-gettext.patch

Patch1: drop-spew.patch

Patch2: gconf-3.2.6-gconf-engine_key_is_writable.patch

Patch99: workaround-crash.patch
Patch100: pkill-hack.patch

BuildRequires: gettext
BuildRequires: gtk-doc >= 0.9
BuildRequires: intltool
BuildRequires: make
BuildRequires: pkgconfig(dbus-glib-1) >= 0.8
BuildRequires: pkgconfig(gobject-introspection-1.0) >= 0.6.7
BuildRequires: pkgconfig(libxml-2.0) >= %{libxml2_version}
%if 0%{?defaults_service}
BuildRequires: pkgconfig(polkit-gobject-1) >= 0.92
%endif
BuildRequires: autoconf automake libtool
BuildRequires: python3-devel

%if 0%{?defaults_service}
Requires: dbus
%endif
Requires: /usr/bin/pkill
Conflicts: GConf2-dbus

Provides: GConf2-gtk = 3.2.6-6

%description
GConf is a process-transparent configuration database API used to
store user preferences. It has pluggable backends and features to
support workgroup administration.

%package devel
Summary: Headers and libraries for GConf development
Requires: %{name} = %{version}-%{release}
Conflicts: GConf2-dbus-devel

%description devel
GConf development package. Contains files needed for doing
development using GConf.

%prep
%autosetup -p1 -n GConf-%{version}

%build
autoreconf --force --install

%configure --disable-static \
      %{?defaults_service:--enable-defaults-service} \
      %{!?defaults_service:--disable-defaults-service} \
      --disable-orbit --without-openldap --disable-gsettings-backend

sed -i -e 's/ -shared / -Wl,-O1,--as-needed\0 /g' -e 's/    if test "$export_dynamic" = yes && test -n "$export_dynamic_flag_spec"; then/      func_append compile_command " -Wl,-O1,--as-needed"\n      func_append finalize_command " -Wl,-O1,--as-needed"\n\0/' libtool

%make_build

%install
%make_install

mkdir -p %{buildroot}%{_sysconfdir}/gconf/schemas
mkdir -p %{buildroot}%{_sysconfdir}/gconf/gconf.xml.system
mkdir -p %{buildroot}%{_rpmconfigdir}/macros.d/
mkdir -p %{buildroot}%{_localstatedir}/lib/rpm-state/gconf
mkdir -p %{buildroot}%{_datadir}/GConf/gsettings

install -p -m 644 %{SOURCE1} %{buildroot}%{_rpmconfigdir}/macros.d/

find %{buildroot} -name "*.la" -type f -delete

mkdir -p %{buildroot}%{_datadir}/GConf/gsettings

%find_lang %name

%post

if [ $1 -gt 1 ]; then
    if ! fgrep -q gconf.xml.system %{_sysconfdir}/gconf/2/path; then
        sed -i -e 's@xml:readwrite:$(HOME)/.gconf@&\n\n# Location for system-wide settings.\nxml:readonly:/etc/gconf/gconf.xml.system@' %{_sysconfdir}/gconf/2/path
    fi
fi


%files -f %{name}.lang
%license COPYING
%doc NEWS README
%config(noreplace) %{_sysconfdir}/gconf/2/path
%dir %{_sysconfdir}/gconf
%dir %{_sysconfdir}/gconf/2
%dir %{_sysconfdir}/gconf/gconf.xml.defaults
%dir %{_sysconfdir}/gconf/gconf.xml.mandatory
%dir %{_sysconfdir}/gconf/gconf.xml.system
%dir %{_sysconfdir}/gconf/schemas
%{_bindir}/gconf-merge-tree
%{_bindir}/gconftool-2
%{_libexecdir}/gconfd-2
%{_libdir}/*.so.*
%{_libdir}/GConf/2/*.so
%dir %{_datadir}/sgml
%{_datadir}/sgml/gconf
%{_datadir}/GConf
%{_mandir}/man1/*
%dir %{_libdir}/GConf
%dir %{_libdir}/GConf/2
%{_rpmconfigdir}/macros.d/macros.gconf2
%if 0%{?defaults_service}
%{_sysconfdir}/dbus-1/system.d/org.gnome.GConf.Defaults.conf
%{_libexecdir}/gconf-defaults-mechanism
%{_datadir}/polkit-1/actions/org.gnome.gconf.defaults.policy
%{_datadir}/dbus-1/system-services/org.gnome.GConf.Defaults.service
%endif
%{_datadir}/dbus-1/services/org.gnome.GConf.service
%{_localstatedir}/lib/rpm-state/gconf/
%{_libdir}/girepository-1.0

%files devel
%{_libdir}/*.so
%{_includedir}/gconf
%{_datadir}/aclocal/*.m4
%{_datadir}/gtk-doc/html/gconf
%{_libdir}/pkgconfig/*
%{_datadir}/gir-1.0

%changelog
* Tue Oct 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.2.6-2
- fix install error

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.2.6-1
- initial build
